<template>
  <q-card
    :square="!isDesktopPlatform"
    :class="{ 'custom-fertilizer-element-edit-form-desktop': isDesktopPlatform }"
  >
    <q-form @submit="onSubmit">
      <q-card-section class="q-pb-xs">
        <div class="text-body2 q-mb-sm">
          <translate>Chemical element:</translate>
        </div>
        <q-select
          v-model="selectedChemicalElement"
          :options="chemicalElementsOptions"
          option-value="id"
          option-label="label"
          filled
          @filter="filterChemicalElement"
          use-input
          input-debounce="200"
          :loading="loadingChemicalElements"
          :label="$gettext('Chemical element')"
          :rules="[
            val => Boolean(val) || $gettext('Select a chemical element'),
            val => isChemicalElementAvailable(val) || $gettext('This chemical element is already used, select another one.')
          ]"
        />
      </q-card-section>

      <q-card-section class="q-py-xs">
        <div class="text-body2 q-mb-sm">
          <translate>Percentage of the fertilizer (by atomic mass):</translate>
        </div>
        <q-input
          v-model.number="percentage"
          step="any"
          filled
          type="number"
          :label="$gettext('Percentage')"
          suffix="%"
          :min="0"
          :max="availablePercentage"
          :rules="[ val => val && val > 0 && val <= availablePercentage || $gettextInterpolate($gettext('Enter a positive number up to %{maxPercentage}'), { maxPercentage: availablePercentage })]"
        />
      </q-card-section>

      <q-card-section
        class="q-py-xs"
        v-if="hasDeterminationMethods"
      >
        <div class="text-body2 q-mb-sm">
          <translate>Composition determination method (optional):</translate>
        </div>
        <q-select
          v-model="selectedDeterminationMethod"
          :options="determinationMethods"
          option-value="id"
          option-label="label"
          clearable
          clear-icon="las la-times-circle"
          filled
          :loading="loadingDeterminationMethods"
          :label="$gettext('Determination method')"
        />
      </q-card-section>

      <q-card-section class="q-py-lg">
        <div class="row justify-end items-center">
          <q-btn
            :label="$gettext('Cancel')"
            flat
            @click="onCancel"
          />
          <q-btn
            :label="$gettext('Remove')"
            flat
            color="red"
            @click="onDelete"
            v-if="!isNew"
          />
          <q-btn
            :label="saveButtonLabel"
            flat
            color="primary"
            type="submit"
          />
        </div>
      </q-card-section>
    </q-form>
  </q-card>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import queryChemicalElements from 'src/pages/holding-campaign/custom-fertilizer/graphql/queryChemicalElements'
import queryDeterminationMethods from 'src/pages/holding-campaign/custom-fertilizer/graphql/queryDeterminationMethods'

export default {
  name: 'CustomFertilizerElementEditForm',
  mixins: [
    PlatformMixin
  ],
  props: {
    id: {
      type: Number,
      default: null
    },
    initialChemicalElement: {
      type: Object,
      default: null
    },
    initialPercentage: {
      type: Number,
      required: true
    },
    initialDeterminationMethod: {
      type: Object,
      default: null
    },
    existingCustomFertilizerElements: {
      type: Array,
      required: true
    }
  },
  emits: ['on-save', 'on-cancel', 'on-delete'],
  data () {
    return {
      selectedChemicalElement: this.initialChemicalElement,
      percentage: this.initialPercentage,
      selectedDeterminationMethod: this.initialDeterminationMethod,
      chemicalElementsFilterValue: null
    }
  },
  apollo: {
    chemicalElements: {
      query: queryChemicalElements,
      notifyOnNetworkStatusChange: true
    },
    determinationMethods: {
      query: queryDeterminationMethods,
      notifyOnNetworkStatusChange: true
    }
  },
  computed: {
    isNew () {
      return !this.id
    },
    saveButtonLabel () {
      return this.isNew ? this.$gettext('Add') : this.$gettext('Update')
    },
    availablePercentage () {
      let availablePercentage = 100
      if (this.existingCustomFertilizerElements?.length) {
        const pct = this.existingCustomFertilizerElements
          .filter(el => el.id !== this.id)
          .reduce((prev, curr) => prev - (curr.percentage ?? 0), 100)
        availablePercentage = Math.round(pct * 100) / 100
      }
      return availablePercentage
    },
    chemicalElementsOptions () {
      const options = this.chemicalElements
      if (this.chemicalElementsFilterValue) {
        return options.filter(v => v.label?.toLowerCase().indexOf(this.chemicalElementsFilterValue) > -1)
      } else {
        return options
      }
    },
    hasDeterminationMethods () {
      return this.determinationMethods?.length
    },
    loadingChemicalElements () {
      return !this.chemicalElements && this.$apollo.queries.chemicalElements.loading
    },
    loadingDeterminationMethods () {
      return !this.determinationMethods && this.$apollo.queries.determinationMethods.loading
    }
  },
  methods: {
    onSubmit () {
      if (this.selectedChemicalElement && this.percentage) {
        this.$emit('on-save', {
          id: this.id,
          chemicalElement: this.selectedChemicalElement,
          percentage: this.percentage,
          determinationMethod: this.selectedDeterminationMethod
        })
      }
    },
    onCancel () {
      this.$emit('on-cancel')
    },
    onDelete () {
      this.$emit('on-delete', this.id)
    },
    filterChemicalElement (val, update, abort) {
      update(() => {
        this.chemicalElementsFilterValue = val.toLowerCase()
      })
    },
    isChemicalElementAvailable ({ id }) {
      return this.initialChemicalElement?.id === id || !this.existingCustomFertilizerElements?.find(({ chemicalElement }) => chemicalElement?.id === id)
    }
  }
}
</script>

<style scoped>
.custom-fertilizer-element-edit-form-desktop {
  min-width: 500px;
}
</style>
